/*  Note: You are free to use whatever license you want.
    Eventually you will be able to edit it within Glade. */

/*  gxhost
 *  Copyright (C) <YEAR> <AUTHORS>
 *
 *  This program is free software; you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation; either version 2 of the License, or
 *  (at your option) any later version.
 *
 *  This program is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.
 *
 *  You should have received a copy of the GNU General Public License
 *  along with this program; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
*/

#ifdef HAVE_CONFIG_H
#  include <config.h>
#endif

#include <stdio.h>
#include <stdlib.h>
#include <string.h>


#include <gtk/gtk.h>
#include "gxhostsrc.h"
#include "gxhostsig.h"

GtkWidget *win_main;
GtkWidget *win_msg;

guint DEFCONTEXT;
char *HISTFILENAME;
GList *HISTORY=NULL;

void StatusBarMsg(char *s)
{
   static int i=0;
   GtkWidget *sbr;   
   
   sbr=gtk_object_get_data(GTK_OBJECT(win_main), "sbr_main");              
   if(i)
     gtk_statusbar_remove(GTK_STATUSBAR(sbr),DEFCONTEXT,i);      
   
   i=gtk_statusbar_push(GTK_STATUSBAR(sbr),DEFCONTEXT,s);   
}

void 
Message(char *title, char *msg)
{
           win_msg=create_win_msg (title,msg);
           gtk_window_set_modal(GTK_WINDOW(win_msg),1);           
           gtk_widget_show(win_msg);
}


void 
SaveCmbList(void)
{
   int i;
   FILE *pf;
   
   GList *paux=HISTORY;
   
   pf=fopen(HISTFILENAME,"w");
   if(!pf)
   {
   	Message("Error","Can't save history file");
   	return;
   }

   for(i=0;i<10 && paux;i++,paux=g_list_next(paux))
   		fprintf(pf,"%s\n",(char *)paux->data);
   	
   fclose(pf);   	
}

void 
Quit(void)
{
   SaveCmbList();
   gtk_main_quit();
} 


void About(void)
{
   Message("About gxhost",
           "\ngxhost ver 0.8.4\n\nA.L.Delgado 2000\naldelgado@arquired.es\n    http://www.arquired.es/users/aldelgado/proy/gxhost   \n\n");
}

/*int MVPSystem(char *s)
{
   FILE *pf;
   char resp[255];
   
   pf=popen(s,"r");
   if(!pf) return(0);
      
   while(!feof(pf))
   {
      fgets(resp,255,pf);   
      g_print("resp :%s\n",resp);
   }
   return(1);
}*/

void LdCmb(FILE *pf,int hostsfile)
{
	char s[255], *p,i;
	gpointer wdg;

	HISTORY=NULL;
   
	wdg=gtk_object_get_data(GTK_OBJECT(win_main), "cmb_host");           
   
 	fgets(s,255,pf);      
	while(!feof(pf))
		{
			if(s[0]!='#')
			{
			        if(s[strlen(s)-1]=='\n') 
 			       		s[strlen(s)-1]=0;			
        		        
        		        if(hostsfile)
        		        {
        			        i=0;        		        
				        p=strtok(s," \t");
				        while(p)
				        {
				           i++;
			        	   if(i==2)
				              HISTORY=g_list_append (HISTORY, strdup(p));
				           p=strtok(NULL," \t");        
             	
				        }     
				 }
				 else
				 {
			              HISTORY=g_list_append (HISTORY, strdup(s));				 
			         }
			}
			
			fgets(s,255,pf);            
		}
	gtk_combo_set_popdown_strings (GTK_COMBO (wdg), HISTORY);
	fclose(pf);
}

void RefreshCmb(void)
{
   FILE *pf;

   pf=fopen(HISTFILENAME,"r");
   
   if(pf)  /* Loading history */
   	{
   		LdCmb(pf,0);
		StatusBarMsg("Loadding hosts list from history file ...");         	
	}   
   else
   	{
		pf=fopen("/etc/hosts","r");
		if(!pf) return;
		LdCmb(pf,1);   
		StatusBarMsg("Loadding hosts list from /etc/hosts...");      
	}
}

int FamilyPos(char *s)
{
   int i;
   char *familyname[5]=
   {
      "INET","DNET","NIS","KRB","LOCAL"
   };
   
   for(i=0;i<5;i++)
      if (!strcmp(s,familyname[i]))
         return(i);
   return(-1);
}

gpointer familyptr[5]={NULL,NULL,NULL,NULL,NULL};

void Refresh(void)
{
   int pos;
   char s[255],*tpl[2],*aux;   
   gpointer wdg,p;   
   FILE *pf;

   

   wdg=gtk_object_get_data(GTK_OBJECT(win_main), "ctr_hosts");           
   
   for(pos=0;pos<5;pos++){
      if(familyptr[pos])
         gtk_ctree_remove_node(GTK_CTREE(wdg),familyptr[pos]);      
      familyptr[pos]=NULL;
   }
         
/*   gtk_ctree_clear(GTK_CTREE(wdg));         */
   
   pf=popen("xhost","r");
   while (!feof(pf))
   {
      fgets(s,255,pf);      
      if(s[strlen(s)-1]=='\n') s[strlen(s)-1]=0;      
/*      g_print("\"%s\"\n",s);*/
      if(strchr(s,':'))
      {
         aux=strtok(s,":\t");
         pos=FamilyPos(aux);
         
         if(pos>=0)
         {
            if(familyptr[pos])
               tpl[0]=strdup("");
            else
               tpl[0]=strdup((aux)?aux:"");            
            
            aux=strtok(NULL,":\t");            
            tpl[1]=strdup((aux)?aux:"");         
/*            g_print("> '%s' - '%s' \n",tpl[0],tpl[1]);*/
            
            p=gtk_ctree_insert_node (GTK_CTREE(wdg),familyptr[pos],NULL,tpl, 0, 
                     NULL, NULL, NULL, NULL, 0,1);         
            if(!familyptr[pos])
               familyptr[pos]=p;
         }
         
      }
   }
   pclose(pf);
   StatusBarMsg("Refreshed list of current allowed hosts");      
}


void AllowAll(void)
{
   system("xhost +");
   Refresh();
   StatusBarMsg("Access allowed to all hosts");   
}



void DenyAll(void)
{
   system("xhost -");
   Refresh();   
   StatusBarMsg("Access denied to all hosts");
}

gint CompareNames(gconstpointer namel,gconstpointer namer)
{
   return((gint)strcmp((char *)namel, (char *) namer));
}

void AllowCurrent(void)
{
   char *auxp,*cmmd;   
   gpointer wdg; 
   GList *p;  
   
   wdg=gtk_object_get_data(GTK_OBJECT(win_main), "cmb_host");           
   auxp=gtk_entry_get_text(GTK_ENTRY(GTK_COMBO(wdg)->entry));         
   
   cmmd=(char *)malloc(strlen(auxp)+20);
   strcpy(cmmd,"xhost +");
   strcat(cmmd,auxp);
   
/*   g_print("cmmd: %s\n",cmmd);   */
   system(cmmd);
   
   Refresh();         
   
   strcpy(cmmd,"Allowed host ");   
   strcat(cmmd,auxp);
   
   StatusBarMsg(cmmd);            


   if((p=g_list_find_custom(HISTORY,auxp,CompareNames)))
   {
   	free(p->data);
   	HISTORY=g_list_remove_link(HISTORY,p);
   }
   	
   HISTORY=g_list_prepend (HISTORY, strdup(auxp));
   gtk_list_clear_items(GTK_LIST(GTK_COMBO(wdg)->list),0,-1);
   gtk_combo_set_popdown_strings (GTK_COMBO (wdg), HISTORY);   

      
   free(cmmd);
   
}

GList *CURRENTNODE=NULL;

void DenyCurrent(void)
{
   char *auxp,*cmmd;      
   gpointer wdg;   
  
   if (CURRENTNODE)
   {   
      wdg=gtk_object_get_data(GTK_OBJECT(win_main), "ctr_hosts");              
      gtk_ctree_node_get_text(GTK_CTREE(wdg),GTK_CTREE_NODE(CURRENTNODE),1,&auxp);
      
        if(strcmp(auxp,""))
        {
   
         cmmd=(char *)malloc(strlen(auxp)+20);
         strcpy(cmmd,"xhost -");
         strcat(cmmd,auxp);
   
         /*   g_print("cmmd: %s\n",cmmd);   */
         system(cmmd);

	 strcpy(cmmd,"Denied host ");   
         strcat(cmmd,auxp);         
         
         Refresh();            
         

   
         StatusBarMsg(cmmd);            
      
         free(cmmd);
         /*   free(auxp);*/
   

        }
   }
   
}


void SetHistFileName(void)
{

  char *s;  
  
  s=getenv("HOME");
  
  HISTFILENAME=(char *) malloc(strlen(s)+20);
  strcpy(HISTFILENAME,s);
  strcat(HISTFILENAME,"/.gxhost.hist");

}

int
main (int argc, char *argv[])
{
   GtkWidget *sbr;   

  
  gtk_set_locale ();
  gtk_init (&argc, &argv);

  SetHistFileName();
  

  /*
   * The following code was added by Glade to create one of each component
   * (except popup menus), just so that you see something after building
   * the project. Delete any components that you don't want shown initially.
   */
  add_pixmap_directory("/usr/share/gxhost");
  add_pixmap_directory("/usr/local/share/gxhost");     
  
  win_main = create_win_main ();
  
  sbr=gtk_object_get_data(GTK_OBJECT(win_main), "sbr_main");                
  DEFCONTEXT=gtk_statusbar_get_context_id (GTK_STATUSBAR(sbr),
                                           "gxhost");
  RefreshCmb();
  Refresh();
  gtk_widget_show (win_main);

  gtk_main ();
  return 0;
}




void
on_quit_activate                       (GtkMenuItem     *menuitem,
                                        gpointer         user_data)
{
  Quit();
}


void
on_allow_all_activate                  (GtkMenuItem     *menuitem,
                                        gpointer         user_data)
{
   AllowAll();
}


void
on_deny_all_activate                   (GtkMenuItem     *menuitem,
                                        gpointer         user_data)
{
   DenyAll();
}


void
on_allow_current_activate              (GtkMenuItem     *menuitem,
                                        gpointer         user_data)
{
   AllowCurrent();
}


void
on_deny_current_activate               (GtkMenuItem     *menuitem,
                                        gpointer         user_data)
{
   DenyCurrent();
}


void
on_refresh_activate                    (GtkMenuItem     *menuitem,
                                        gpointer         user_data)
{
  Refresh();
}



void
on_help_activate                       (GtkMenuItem     *menuitem,
                                        gpointer         user_data)
{
   About();
}


void
on_about_activate                      (GtkMenuItem     *menuitem,
                                        gpointer         user_data)
{
   About();
}


void
on_btn_allowall_clicked                (GtkButton       *button,
                                        gpointer         user_data)
{
   AllowAll();
}


void
on_btn_denyall_clicked                 (GtkButton       *button,
                                        gpointer         user_data)
{
   DenyAll();
}


void
on_btn_refresh_clicked                 (GtkButton       *button,
                                        gpointer         user_data)
{
  Refresh();
}


void
on_btn_help_clicked                    (GtkButton       *button,
                                        gpointer         user_data)
{
   About();
}


void
on_btn_exit_clicked                    (GtkButton       *button,
                                        gpointer         user_data)
{
  Quit();
}


void
on_btn_msgok_clicked                   (GtkButton       *button,
                                        gpointer         user_data)
{
   gtk_widget_destroy(win_msg);
}



void
on_helpm_activate                      (GtkMenuItem     *menuitem,
                                        gpointer         user_data)
{

}


gboolean
on_win_main_delete_event               (GtkWidget       *widget,
                                        GdkEvent        *event,
                                        gpointer         user_data)
{
  Quit();
  return FALSE;
}


void
on_btn_allow_clicked                   (GtkButton       *button,
                                        gpointer         user_data)
{
   AllowCurrent();
}



void
on_btn_deny_clicked                    (GtkButton       *button,
                                        gpointer         user_data)
{
   DenyCurrent();
}


void
on_ctr_hosts_tree_select_row           (GtkCTree        *ctree,
                                        GList           *node,
                                        gint             column,
                                        gpointer         user_data)
{
    CURRENTNODE=node;
}


void
on_ctr_hosts_tree_unselect_row         (GtkCTree        *ctree,
                                        GList           *node,
                                        gint             column,
                                        gpointer         user_data)
{
    CURRENTNODE=NULL; 
}


void
on_hide_Toolbar_activate               (GtkMenuItem     *menuitem,
                                        gpointer         user_data)
{
   static int status=1;
   GtkWidget *tbr;   
   
   tbr=gtk_object_get_data(GTK_OBJECT(win_main), "handlebox2");              
   
   if(status)
      gtk_widget_hide(tbr);      
   else   
      gtk_widget_show(tbr);   
      
   status=!status;
}


gboolean
on_ctr_hosts_key_press_event           (GtkWidget       *widget,
                                        GdkEventKey     *event,
                                        gpointer         user_data)
{
  /* g_print("-- %d",event->keyval);*/
  if(event->keyval==65535 || event->keyval==45)
     DenyCurrent();
     
  return FALSE;
}

